           (*-------------------------------------------*
            |        CSP-Prover on Isabelle2004         |
            |               December 2004               |
            |               February 2005  (modified)   |
            |                   June 2005  (modified)   |
            |                                           |
            |        CSP-Prover on Isabelle2005         |
            |               November 2005  (modified)   |
            |                                           |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory CSP_F = CSP_F_tactic + CSP_T:

(*-------------------------------------------------------*
 |                                                       |
 |  The folloing def have already added in CSP_T         |
 |                                                       |
 |   Procfun_def                                         |
 |   ProcX_def                                           |
 |   gTickX_def                                          |
 |   guardX_def                                          |
 |   nohideX_def                                         |
 |                                                       |
 |   Ext_choice_step_def                                 |
 |   Parallel_step_def                                   |
 |   Hiding_step_def                                     |
 |   Renaming_step_def                                   |
 |   Seq_compo_step_def                                  |
 |   inj_on_def                                          |
 |                                                       |
 *-------------------------------------------------------*)

(*----------------------------------------------------------------------*
 |                                                                      |
 |  To unfold (resp. fold) syntactic-sugar for Ext_ and Int_pre_choices |
 |  choices, use "unfold csp_prefix_ss_def"                             |
 |                                                                      |
 *----------------------------------------------------------------------*)

(*------------------------------------*
 |                                    |
 |    laws automatically applied      |
 |                                    |
 *------------------------------------*)

(* intro! intro? are automatically applied by "rule".     *)
(* intro! is automatically applied by "rules" and "auto". *)

(* CSP_F_law_commut *)

declare cspF_commut                                  [simp]

(* CSP_F_law_ref *)

declare cspF_Int_choice_right                        [intro!]
declare cspF_Rep_int_choice_right                    [intro!]

(* CSP_F_law_SKIP *)

declare cspF_SKIP                                    [simp]
lemmas  cspF_SKIP_sym                                [simp]
      = cspF_SKIP[THEN cspF_sym]

(* CSP_F_law_decompo *)

declare cspF_rm_head                                 [intro!]
declare cspF_decompo                                 [simp]

(* CSP_F_law_dist *)

declare cspF_dist                                    [simp]
lemmas  cspF_dist_sym                                [simp]
      = cspF_dist[THEN cspF_sym]

declare cspF_Rep_dist                                [simp]
lemmas  cspF_Rep_dist_sym                            [simp]
      = cspF_Rep_dist[THEN cspF_sym]

declare cspF_unwind                                  [simp]
lemmas  cspF_unwind_sym                              [simp]
      = cspF_unwind[THEN cspF_sym]

(* CSP_F_law_step *)

declare cspF_step                                    [simp]
lemmas  cspF_step_sym                                [simp]
      = cspF_step[THEN cspF_sym]

(* CSP_F_law_etc *)

declare cspF_choice_Conditional                      [simp]

end
