           (*-------------------------------------------*
            |  The Dining Mathematicians in CSP-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |             November 2005 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM5_Spc_Imp = DM4_Spc_def:

(*****************************************************************

         1. proves lemma for Spc <=F Imp
         2.
         3. 
         4. 

 *****************************************************************)

(*** Back0_Back1 ***)

lemma Back0_Back1:
  "SpcDef (Spc_to_Imp, TH0_TH1) <=F
   (Back0 -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| Back1 -> (ImpFix TH1))
   -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (tactic {* cspF_step_tac 1 *})+
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas Back0_Back1_simp[simp] = Back0_Back1[simplified]

(*** Eat0_Back1 ***)

lemma Eat0_Back1: 
  "~ ODD x ==> 
   SpcDef (Spc_to_Imp, TH0_TH1) <=F
   (Eat0 -> (ImpFix (EAT0 x)) |[CH0]| (ImpFix (VAR x)) |[CH1]| Back1 -> (ImpFix TH1)) 
      -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (tactic {* cspF_step_tac 1 *})+
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas Eat0_Back1_simp[simp] = Eat0_Back1[simplified]

(*** Back0_Eat1 ***)

lemma Back0_Eat1: 
  "ODD x
   ==> 
   SpcDef (Spc_to_Imp, TH0_TH1) <=F    
   (Back0 -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| Eat1 -> (ImpFix (EAT1 x))) 
      -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (tactic {* cspF_step_tac 1 *})+
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas Back0_Eat1_simp[simp] = Back0_Eat1[simplified]

lemma EAT0_Back1: 
  "~ ODD x
   ==> 
   SpcDef (Spc_to_Imp, EAT0_TH1) <=F
   ((ImpFix (EAT0 x)) |[CH0]| (ImpFix (VAR x)) 
                      |[CH1]| Back1 -> (ImpFix TH1)) -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (tactic {* cspF_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas EAT0_Back1_simp[simp] = EAT0_Back1[simplified]

(*** Back0_EAT1 ***)

lemma Back0_EAT1:
  "ODD x
   ==> 
    SpcDef (Spc_to_Imp, TH0_EAT1) <=F
   (Back0 -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix (EAT1 x)))
    -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (tactic {* cspF_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas Back0_EAT1_simp[simp] = Back0_EAT1[simplified]

(*** Back0_TH1  ***)

(* declare SpcDef.simps [simp del] *)

lemma Back0_TH1:
  "SpcDef (Spc_to_Imp, TH0_TH1) <=F
  (Back0 -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix TH1)) -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)+
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (case_tac "ODD x")
apply (tactic {* cspF_simp_tac 1 *})+
done

lemmas Back0_TH1_simp[simp] = Back0_TH1[simplified]

(*** TH0_Back1  ***)

lemma TH0_Back1:
  "SpcDef (Spc_to_Imp, TH0_TH1) <=F
    ((ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| Back1 -> (ImpFix TH1)) -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)+
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (case_tac "ODD x")
apply (tactic {* cspF_simp_tac 1 *})+
done

lemmas TH0_Back1_simp[simp] = TH0_Back1[simplified]

(*** TH0_Eat1 ***)

lemma TH0_Eat1:
  "ODD x
   ==> 
   SpcDef (Spc_to_Imp, TH0_TH1) <=F
   ((ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| Eat1 -> (ImpFix (EAT1 x))) 
    -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})+
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_step_right_tac 1 *})+
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas TH0_Eat1_simp[simp] = TH0_Eat1[simplified]

(*** Eat0_TH1 ***)

lemma Eat0_TH1:
  "~ ODD x
   ==> 
  SpcDef (Spc_to_Imp, TH0_TH1) <=F
   (Eat0 -> (ImpFix (EAT0 x)) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix TH1))
    -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})+
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_step_right_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas Eat0_TH1_simp[simp] = Eat0_TH1[simplified]

(*** TH0_TH1 ***)

lemma TH0_TH1:
  "SpcDef (Spc_to_Imp, TH0_TH1) <=F
    ((ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix TH1)) -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule)

apply (case_tac "ODD x")
apply (tactic {* cspF_simp_tac 1 *})+

apply (case_tac "ODD x")
apply (tactic {* cspF_simp_tac 1 *})+
done

lemmas TH0_TH1_simp[simp] = TH0_TH1[simplified]

(*** Back0_TH0_TH1 ***)

lemma Back0_TH0_WR1:
  "ODD x
    ==> 
        SpcDef (Spc_to_Imp, TH0_TH1) <=F
        Back0 -> ((ImpFix TH0) |[CH0]| (ImpFix (VAR (3 * x + 1))) |[CH1]| (ImpFix TH1))
         -- (CH0 Un CH1)"
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)+
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="(3 * x + 1)" in exI)
apply (simp)
done

lemmas Back0_TH0_WR1_simp[simp] = Back0_TH0_WR1[simplified]

(*** Back1_TH0_TH1 ***)

lemma Back1_TH0_WR1:
  "ODD x
    ==> 
        SpcDef (Spc_to_Imp, TH0_TH1) <=F
        Back1 -> ((ImpFix TH0) |[CH0]| (ImpFix (VAR (3 * x + 1))) |[CH1]| (ImpFix TH1))
         -- (CH0 Un CH1)"
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)+
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="(3 * x + 1)" in exI)
apply (simp)
done

lemmas Back1_TH0_WR1_simp[simp] = Back1_TH0_WR1[simplified]

(*** Back0_WR1 ***)

lemma Back0_WR1:
  "ODD x
   ==> 
    SpcDef (Spc_to_Imp, TH0_TH1) <=F
   (Back0 -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) 
                          |[CH1]| WR1 (3 * x + 1) -> (ImpFix TH1)) 
   -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas Back0_WR1_simp[simp] = Back0_WR1[simplified]

(*** WR0_Back1 ***)

lemma WR0_Back1:
  "~ ODD x
   ==> 
    SpcDef (Spc_to_Imp, TH0_TH1) <=F
   (WR0 (x div 2) -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| Back1 -> (ImpFix TH1)) 
       -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas WR0_Back1_simp[simp] = WR0_Back1[simplified]

(*** TH0_WR1 ***)

lemma TH0_WR1:
  "ODD x
   ==> 
   SpcDef (Spc_to_Imp, TH0_TH1) <=F
   ((ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| WR1 (3 * x + 1) -> (ImpFix TH1)) 
      -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})+
apply (rule)
apply (rule)
apply (tactic {* cspF_simp_with_tac "fold_Imp_rules" 1 *})+
apply (rule cspF_Timeout_right)
apply (simp)+

apply (tactic {* cspF_simp_with_tac "fold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (rule cspF_Timeout_right)
apply (simp)+
done

lemmas TH0_WR1_simp[simp] = TH0_WR1[simplified]

(*** WR0_TH1 ***)

lemma WR0_TH1:
  "~ ODD x
   ==> 
   SpcDef (Spc_to_Imp, TH0_TH1) <=F
   (WR0 (x div 2) -> (ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix TH1))
     -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule)
apply (tactic {* cspF_simp_with_tac "fold_Imp_rules" 1 *})
done

lemmas WR0_TH1_simp[simp] = WR0_TH1[simplified]

(*** EAT0_TH1 ***)

lemma EAT0_TH1:
  "~ ODD x
   ==> 
   SpcDef (Spc_to_Imp, EAT0_TH1) <=F
    ((ImpFix (EAT0 x)) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix TH1)) -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas EAT0_TH1_simp[simp] = EAT0_TH1[simplified]

(*** TH0_EAT1 ***)

lemma TH0_EAT1:
  "ODD x
   ==> 
   SpcDef (Spc_to_Imp, TH0_EAT1) <=F
    ((ImpFix TH0) |[CH0]| (ImpFix (VAR x)) |[CH1]| (ImpFix (EAT1 x))) -- (CH0 Un CH1)"
apply (tactic {* cspF_simp_with_tac "unfold_Imp_rules" 1 *})
apply (rule cspF_Timeout_right)
apply (tactic {* cspF_light_step_tac 1 *})
apply (auto intro!: cspF_decompo_subset)
apply (tactic {* cspF_simp_tac 1 *})+
apply (rule cspF_Int_choice_left1)
apply (rule cspF_Int_choice_left2)
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="x" in exI)
apply (simp)
done

lemmas TH0_EAT1_simp[simp] = TH0_EAT1[simplified]

(*********************************************************
                  ALL n. Spc <=F Imp n
 *********************************************************)

lemma Spc_ref_Seq: "Spc <=F Imp n"
apply (simp add: Spc_def Imp_def)
apply (rule cspF_fp_induct_cms[of _ Spc_to_Imp])
apply (simp_all)

(*** body ***)
apply (rule cspF_Int_choice_left1)+
apply (rule cspF_Rep_int_choice_left)
apply (simp)
apply (rule_tac x="n" in exI)
apply (simp)

apply (induct_tac pn)
apply (auto)
done

end
